/*++

Copyright (C) 2019 3MF Consortium

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Abstract:

NMR_Spec_Version.h defines the current implementation version.

--*/

#ifndef __NMR_SPECVERSION
#define __NMR_SPECVERSION

// version of the core-specification implemented by this library
#define NMR_SPECVERSION_MAJOR 1
#define NMR_SPECVERSION_MINOR 2
#define NMR_SPECVERSION_MICRO 3

// Interface version for extension API
#define NMR_SPECVERSION_MATERIAL_MAJOR 1
#define NMR_SPECVERSION_MATERIAL_MINOR 1
#define NMR_SPECVERSION_MATERIAL_MICRO 0

#define NMR_SPECVERSION_PRODUCTION_MAJOR 1
#define NMR_SPECVERSION_PRODUCTION_MINOR 1
#define NMR_SPECVERSION_PRODUCTION_MICRO 2

#define NMR_SPECVERSION_BEAMLATTICE_MAJOR 1
#define NMR_SPECVERSION_BEAMLATTICE_MINOR 1
#define NMR_SPECVERSION_BEAMLATTICE_MICRO 0

#define NMR_SPECVERSION_SLICE_MAJOR 1
#define NMR_SPECVERSION_SLICE_MINOR 0
#define NMR_SPECVERSION_SLICE_MICRO 2

#define NMR_SPECVERSION_SECURECONTENT_MAJOR 1
#define NMR_SPECVERSION_SECURECONTENT_MINOR 0
#define NMR_SPECVERSION_SECURECONTENT_MICRO 2

#endif // __NMR_SPECVERSION
